/*
   program : various

   $Source: /home/yee/C/RCS/filter.h,v $
   $Author: yee $
   $Date: 1999/02/10 16:39:47 $
   $Revision: 2.7 $

   Parameters : none

   Assumptions : none known

   Bugs : none known

   To Do : nothing

   This is the header file for filter.c

   $Log: filter.h,v $
   Revision 2.7  1999/02/10 16:39:47  yee
   *** empty log message ***

   Revision 2.6  1999/01/16 14:33:19  yee
   *** empty log message ***

   Revision 2.0  1997/04/28 22:16:26  yee
   separated the skeleton of generating filters from the filter definition.

   Copyright 1997,1998,1999 by Conway Yee.  All rights reserved.
*/
 
#ifndef FILTER_H
#define FILTER_H

#include "mutil.h"

#if defined(FILTER_DOUBLE) || defined(DOUBLE)
#define FILTER_NUMBER double

#define FILTER_ELEMENT lcomplex
      FILTER_ELEMENT *AppendComplexFilter(FILTER_ELEMENT *,int,int,
                                          double (*)(),void *);
      FILTER_ELEMENT *DefineComplexFilter(FILTER_ELEMENT *,int,int,
                                              double (*)(),void *);
      FILTER_ELEMENT *AppendComplexCenteredFilter(FILTER_ELEMENT *,int,int,
                                                  double (*)(),void *);
      FILTER_ELEMENT *DefineComplexCenteredFilter(FILTER_ELEMENT *,int,int,
                                              double (*)(),void *);
#undef FILTER_ELEMENT
#define FILTER_ELEMENT double
      FILTER_ELEMENT *AppendRealFilter(FILTER_ELEMENT *,int,int,double (*)(),
                                         void *);
      FILTER_ELEMENT *DefineRealFilter(FILTER_ELEMENT *,int,int,double (*)(),
                                             void *);
      FILTER_ELEMENT *AppendRealCenteredFilter(FILTER_ELEMENT *,int,int,
                                               double (*)(),void *);
      FILTER_ELEMENT *DefineRealCenteredFilter(FILTER_ELEMENT *,int,int,
                                               double (*)(),void *);
#undef FILTER_ELEMENT
#elif defined(FILTER_SINGLE) || defined(SINGLE)
#define FILTER_NUMBER float

#define FILTER_ELEMENT complex
      FILTER_ELEMENT *AppendComplexFilter(FILTER_ELEMENT *,int,int,
                                          double (*)(),void *);
      FILTER_ELEMENT *DefineComplexFilter(FILTER_ELEMENT *,int,int,
                                          double (*)(),void *);
      FILTER_ELEMENT *AppendComplexCenteredFilter(FILTER_ELEMENT *,int,int,
                                                  double (*)(),void *);
      FILTER_ELEMENT *DefineComplexCenteredFilter(FILTER_ELEMENT *,int,int,
                                                  double (*)(),void *);
#undef FILTER_ELEMENT
#define FILTER_ELEMENT float
      FILTER_ELEMENT *AppendRealFilter(FILTER_ELEMENT *,int,int,double (*)(),
                                         void *);
      FILTER_ELEMENT *DefineRealFilter(FILTER_ELEMENT *,int,int,double (*)(),
                                             void *);
      FILTER_ELEMENT *AppendRealCenteredFilter(FILTER_ELEMENT *,int,int,
                                               double (*)(),void *);
      FILTER_ELEMENT *DefineRealCenteredFilter(FILTER_ELEMENT *,int,int,
                                               double (*)(),void *);
#undef FILTER_ELEMENT
#else
#error SINGLE_VS_DOUBLE_NOT_DEFINED
#endif

#ifdef KAISER
    extern double KaiserFree;   /* degree of freedom needed by Kaiser window */
#endif KAISER

                            /* unfortunately, it is not possible to use
                               #define FILTER here since calling functions
                               may call different filters at different times */
  double hamming(int,int,void *);
  double hanning(int,int,void *);
  double rect(int,int,void *);
  double bartlett(int,int,void *);
  double blackman(int,int,void *);
  double kaiser(int,int,void *);
  double welch(int,int,void *);

#endif FILTER_H
